module Pasta
  module Ingredients
    
    BLOCKQUOTE = /\A {0,3}(>.+?)(^\s*[\n\r]|\z)/m 
    
    def blockquotes(text, html)
      text.sub!(BLOCKQUOTE) do |match|
        inner_text, inner_html = $1, ''
        inner_text.gsub!(/^>/, '')
        while inner_text != '' do
          if grammars.key? :blockquotes
            grammars[:blockquotes].each do |rule|
              inner_text, inner_html = send(rule, inner_text, inner_html)
            end
          end
        end
        html << "<blockquote>\n#{inner_html.strip}\n</blockquote>\n\n"
        match = ''
      end
      [text, html]   
    end
  end
end