module Pasta
  module Ingredients
    
    LIST = /\A\s{0,3}(([-*+]|([0-9]+)\.) .+?)((^\s*[\n\r])|\z)/m
    
    def lists(text, html)
      text.sub!(LIST) do |match|
        inner_text, inner_html, list_type = $1, '', 'ul'
        
        # determine the list_type
        list_type = 'ol' unless %w{- * +}.include? $1.strip[0]
        
        # extract list items
        inner_html = list_items(inner_text)
        
        html << "<#{list_type}>\n#{inner_html}</#{list_type}>\n\n"
        match = ''
      end
      [text, html]
    end
    
    def list_items(text)
      html = ''
      text.gsub(/^([-*+]|\d+\.) (.+?)$(?=([\n\r]([*+-]|(\d+\.))|\z))/m) do |match| 
        html << "<li>#{$2.gsub(/\n\s+/, ' ').strip}</li>\n"
        match = ''
      end
      html
    end
  end
end