module Pasta
  module Ingredients

    PARAGRAPH   = /\A(?![>])(.+?)((^\s*[\n\r])|\z)/m
  
    def paragraphs(text, html)
      text.sub!(PARAGRAPH) do |match| 

        inner_text, inner_html = $1, ''
        inner_text.gsub!(/[ ]{2,}[\n\r]/, "<br />\n")      
        inner_text.strip!

        if grammars.key? :paragraphs
          grammars[:paragraphs].each do |rule|
            inner_text, inner_html = send(rule, inner_text, '')
          end
          inner_text = inner_html unless inner_html == ''
        end

        html << "<p>#{inner_text}</p>\n\n" unless inner_text == ''
        match = ''
      end
      [text, html]  
    end 

  end
end