module Pasta
  module Recipes
    class Gruber < Base

      # Define the grammars
      grammar(:html) { 
        [:automatic_links, :links, :empty_lines, :page_breaks, :codeblocks, :blockquotes, :lists, :atx_headings, :setext_headings, :paragraphs] 
      }
      grammar(:blockquotes) { 
        [:empty_lines, :page_breaks, :codeblocks, :blockquotes, :lists, :atx_headings, :setext_headings, :paragraphs] 
      }
      grammar(:lists) { 
        [:empty_lines, :codeblocks, :blockquotes, :lists, :atx_headings, :setext_headings, :paragraphs] 
      }
      grammar(:atx_headings) { 
        [:emphasis] 
      }
      grammar(:setext_headings) { 
        [:emphasis] 
      }
      grammar(:paragraphs) { 
        [:code, :emphasis] 
      }

    end
  end
end